/*
  Name: DS18B20-Logger 
  Copyright: -
  Author: Skalski Lukasz
  Description: ver. 1.01
*/

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>
#include <string.h>

//ZMIENNE
time_t czas;

//PROTOTYPY FUNKCJI
int liczba_czujnikow(void);							//odczyt liczby podłączonych czujników
int wyrejestruj(int liczba_czujnikow);						//wyrejestrowanie z systemu określonej liczby czujnikow
int skanuj(void);								//skanowanie magistrali
int odczytaj_zapisz_raport(int liczba_czujnikow);				//odczyt temperatury i zapis pliku raportu


int main (int argc, char *argv[]){

	while(1){
		sleep(170);	
		wyrejestruj (liczba_czujnikow());
		skanuj();
		odczytaj_zapisz_raport(liczba_czujnikow());
	}
return 0;
}


/* ------------------------------------------------------------------------------- */
int liczba_czujnikow(void){

	FILE *fd;
	char bufor [4];
	int temp;
	
	fd = fopen("/sys/bus/w1/devices/w1_bus_master1/w1_master_slave_count", "r");

	if (!fd){
		fprintf (stderr, "Blad otwarcia pliku\n");
		return -1;
	}else{

		if (!fgets(bufor,3,fd)){
			fprintf (stderr, "Blad odczytu danych\n");
			return -1;
		}else{
			temp = atoi (bufor);
		}
	}
	fclose (fd);
	return temp;
}

/* ------------------------------------------------------------------------------- */
int wyrejestruj(int liczba_czujnikow){

	FILE *fd, *fp;
	char bufor [20];
	int temp;
	
	fd = fopen("/sys/bus/w1/devices/w1_bus_master1/w1_master_slaves", "r");

	if (!fd){
		fprintf (stderr, "Blad otwarcia pliku\n");
		return -1;
	}else{
		for (temp = 1 ; temp <= liczba_czujnikow ; temp++){

			if (!fgets(bufor,16,fd)){
				fprintf (stderr, "Blad odczytu danych\n");
				return -1;
			}else{
				fp = fopen("/sys/bus/w1/devices/w1_bus_master1/w1_master_remove", "w");
				fprintf (fp,"%s", bufor);
				fseek(fd, 1L, 1);
				fclose(fp);
			}
		}
	}
	fclose (fd);
	return 0;
}

/* ------------------------------------------------------------------------------- */
int skanuj(void){

	FILE *fd;
	
	fd = fopen("/sys/bus/w1/devices/w1_bus_master1/w1_master_search", "w");

	if (!fd){
		fprintf (stderr, "Blad otwarcia pliku\n");
		return -1;
	}else{
		fprintf (fd,"1");
	}
	fclose (fd);
	sleep(10);
	return 0;
}

/* ------------------------------------------------------------------------------- */
int odczytaj_zapisz_raport(int liczba_czujnikow){

	FILE *fd, *fp, *fr;
	char bufor [20];
	char path [50] ="";
	int temp1,temp2;

	time (&czas);
	
	fd = fopen("/sys/bus/w1/devices/w1_bus_master1/w1_master_slaves", "r");

	if (!fd){
		fprintf (stderr, "Blad otwarcia pliku\n");
		return -1;
	}else{
		for (temp1 = 1 ; temp1 <= liczba_czujnikow ; temp1++){

			if (!fgets(bufor,16,fd)){
				fprintf (stderr, "Blad odczytu danych\n");
				return -1;
			}else{
				fseek(fd, 1L, 1);
				
   				strcat(path, "/sys/bus/w1/devices/");
				strcat(path, bufor);
				strcat(path, "/w1_slave");

				fp = fopen(path, "r");
				path[0] = '\0';

				fr = fopen("/home/root/raport2", "a");

				//data
				fprintf (fr, "---\n%s",ctime(&czas));

				//numer czujnika
				fprintf (fr, "Czujnik: %s\n",bufor);

				//crc
				fseek(fp, 36L, 0);
				fgets(bufor,5,fp);
				fprintf (fr, "CRC: %s",bufor);

				//temperatura
				fseek(fp, 69L, 0);
				fgets(bufor,6,fp);
				temp2 = atoi (bufor);
				fprintf (fr, "Temp: %.03f\n",(float)temp2/1000);		

				fclose(fr);
				fclose(fp);				
			}
		}
	}
	fclose (fd);
	return 0;
}
/* ------------------------------------------------------------------------------- */


